Annotation of openbsd/fw_update/fw_install.sh, Revision 1.138
1.1 afresh1 1: #!/bin/ksh
1.36 afresh1 2: # $OpenBSD$
1.50 afresh1 3: #
1.38 afresh1 4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
5: #
6: # Permission to use, copy, modify, and distribute this software for any
7: # purpose with or without fee is hereby granted, provided that the above
8: # copyright notice and this permission notice appear in all copies.
9: #
10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17:
1.95 afresh1 18: set -o errexit -o pipefail -o nounset -o noclobber -o noglob
1.85 afresh1 19: set +o monitor
1.77 afresh1 20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50 afresh1 21:
22: CFILE=SHA256.sig
23: DESTDIR=${DESTDIR:-}
24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
25:
26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
28:
29: HTTP_FWDIR="$VNAME"
1.52 afresh1 30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
31: /var/run/dmesg.boot | sed '$!d' )
1.50 afresh1 32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22 afresh1 33:
1.50 afresh1 34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8 afresh1 36:
1.131 afresh1 37: DRYRUN=false
1.138 ! afresh1 38: VERBOSE=0
1.111 afresh1 39: DELETE=false
1.87 afresh1 40: DOWNLOAD=true
41: INSTALL=true
1.69 afresh1 42: LOCALSRC=
43:
1.126 afresh1 44: unset FTPPID
1.129 afresh1 45: unset FWPKGTMP
1.126 afresh1 46: REMOVE_LOCALSRC=false
47: cleanup() {
1.127 afresh1 48: set +o errexit # ignore errors from killing ftp
1.128 afresh1 49: [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
1.129 afresh1 50: [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
1.126 afresh1 51: "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
52: }
53: trap cleanup EXIT
54:
1.8 afresh1 55: tmpdir() {
56: local _i=1 _dir
57:
1.50 afresh1 58: # If we're not in the installer,
1.79 afresh1 59: # we have mktemp and a more hostile environment.
1.50 afresh1 60: if [ -x /usr/bin/mktemp ]; then
61: _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44 afresh1 62: else
1.50 afresh1 63: until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44 afresh1 64: ((++_i < 10000)) || return 1
65: done
66: fi
1.50 afresh1 67:
1.8 afresh1 68: echo "$_dir"
69: }
1.6 afresh1 70:
1.50 afresh1 71: fetch() {
1.126 afresh1 72: local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
1.6 afresh1 73:
1.79 afresh1 74: # If we're not in the installer,
75: # we have su(1) and doas(1) is unlikely to be configured.
1.85 afresh1 76: set -o monitor # make sure ftp gets its own process group
77: (
1.138 ! afresh1 78: _flags=-vm
! 79: case "$VERBOSE" in
! 80: 0|1) _flags=-VM ;;
! 81: 2) _flags=-Vm ;;
! 82: esac
1.53 afresh1 83: if [ -x /usr/bin/su ]; then
1.85 afresh1 84: exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.138 ! afresh1 85: "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $_flags -o- '$_src'" > "$_dst"
1.42 afresh1 86: else
1.85 afresh1 87: exec /usr/bin/doas -u "$_user" \
1.138 ! afresh1 88: /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $_flags -o- "$_src" > "$_dst"
1.42 afresh1 89: fi
1.126 afresh1 90: ) & FTPPID=$!
1.85 afresh1 91: set +o monitor
92:
93: SECONDS=0
94: _last=0
1.126 afresh1 95: while kill -0 -"$FTPPID" 2>/dev/null; do
1.85 afresh1 96: if [[ $SECONDS -gt 12 ]]; then
97: set -- $( ls -ln "$_dst" 2>/dev/null )
98: if [[ $_last -ne $5 ]]; then
99: _last=$5
100: SECONDS=0
101: sleep 1
102: else
1.137 afresh1 103: kill -INT -"$FTPPID" 2>/dev/null
1.92 afresh1 104: _error=" (timed out)"
1.85 afresh1 105: fi
106: else
107: sleep 1
108: fi
109: done
110:
111: set +o errexit
1.126 afresh1 112: wait "$FTPPID"
1.85 afresh1 113: _exit=$?
114: set -o errexit
115:
1.126 afresh1 116: unset FTPPID
1.6 afresh1 117:
1.50 afresh1 118: if [ "$_exit" -ne 0 ]; then
1.69 afresh1 119: rm -f "$_dst"
1.92 afresh1 120: echo "Cannot fetch $_src$_error" >&2
1.50 afresh1 121: return 1
122: fi
1.6 afresh1 123: }
124:
1.50 afresh1 125: verify() {
126: # On the installer we don't get sha256 -C, so fake it.
1.69 afresh1 127: if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
128: echo "Checksum test for ${1##*/} failed." >&2
1.50 afresh1 129: return 1
130: fi
1.6 afresh1 131: }
132:
1.124 afresh1 133: firmware_in_dmesg() {
1.90 afresh1 134: local _d _m _line _dmesgtail _last='' _nl=$( echo )
1.1 afresh1 135:
1.50 afresh1 136: # When we're not in the installer, the dmesg.boot can
137: # contain multiple boots, so only look in the last one
1.133 afresh1 138: _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )"
1.50 afresh1 139:
1.89 afresh1 140: grep -v '^[[:space:]]*#' "$FWPATTERNS" |
141: while read -r _d _m; do
142: [ "$_d" = "$_last" ] && continue
1.90 afresh1 143: [ "$_m" ] || _m="${_nl}${_d}[0-9] at "
144: [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
1.83 afresh1 145:
1.89 afresh1 146: if [[ $_dmesgtail = *$_m* ]]; then
147: echo "$_d"
148: _last="$_d"
149: fi
150: done
1.50 afresh1 151: }
1.14 afresh1 152:
1.50 afresh1 153: firmware_filename() {
1.56 afresh1 154: local _f
155: _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
156: ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
157: echo "$_f"
1.50 afresh1 158: }
1.7 afresh1 159:
1.57 afresh1 160: firmware_devicename() {
161: local _d="${1##*/}"
162: _d="${_d%-firmware-*}"
163: echo "$_d"
164: }
165:
1.50 afresh1 166: installed_firmware() {
1.110 afresh1 167: local _pre="$1" _match="$2" _post="$3" _firmware
1.123 afresh1 168: set -sA _firmware -- $(
1.109 afresh1 169: set +o noglob
170: grep -Fxl '@option firmware' \
1.110 afresh1 171: "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
1.109 afresh1 172: 2>/dev/null || true
173: set -o noglob
174: )
175:
176: [ "${_firmware[*]:-}" ] || return 0
177: for fw in "${_firmware[@]}"; do
178: fw="${fw%/+CONTENTS}"
1.50 afresh1 179: echo "${fw##*/}"
180: done
181: }
1.1 afresh1 182:
1.124 afresh1 183: detect_firmware() {
184: local _devices _last='' _d
185:
186: set -sA _devices -- $(
187: firmware_in_dmesg
188: for _d in $( installed_firmware '*' '-firmware-' '*' ); do
1.135 afresh1 189: firmware_devicename "$_d"
1.124 afresh1 190: done
191: )
192:
193: [ "${_devices[*]:-}" ] || return 0
194: for _d in "${_devices[@]}"; do
1.135 afresh1 195: [ "$_last" = "$_d" ] && continue
196: echo "$_d"
1.124 afresh1 197: _last="$_d"
198: done
199: }
200:
1.50 afresh1 201: add_firmware () {
1.106 afresh1 202: local _f="${1##*/}" _pkgname
1.129 afresh1 203: FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
1.138 ! afresh1 204: local _flags=-vm
! 205: case "$VERBOSE" in
! 206: 0|1) _flags=-VM ;;
! 207: 2|3) _flags=-Vm ;;
! 208: esac
! 209:
! 210: [ "$VERBOSE" -eq 1 ] && echo -n "Install ${_f} ..."
! 211:
! 212: ftp -N "${0##/}" -D "Install" "$_flags" -o- "file:${1}" |
1.129 afresh1 213: tar -s ",^\+,${FWPKGTMP}/+," \
1.69 afresh1 214: -s ",^firmware,${DESTDIR}/etc/firmware," \
215: -C / -zxphf - "+*" "firmware/*"
1.1 afresh1 216:
1.129 afresh1 217: _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
1.106 afresh1 218: if [ ! "$_pkgname" ]; then
219: echo "Failed to extract name from $1, partial install" 2>&1
1.129 afresh1 220: rm -rf "$FWPKGTMP"
221: unset FWPKGTMP
1.106 afresh1 222: return 1
223: fi
224:
1.50 afresh1 225: # TODO: Should we mark these so real fw_update can -Drepair?
1.129 afresh1 226: ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
1.50 afresh1 227: /^@comment pkgpath/ -1a
228: @option manual-installation
229: @option firmware
230: @comment install-script
231: .
232: w
233: EOL
1.106 afresh1 234:
1.129 afresh1 235: chmod 755 "$FWPKGTMP"
236: mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
237: unset FWPKGTMP
1.138 ! afresh1 238:
! 239: [ "$VERBOSE" -eq 1 ] && echo " done."
1.50 afresh1 240: }
1.22 afresh1 241:
1.50 afresh1 242: delete_firmware() {
1.51 afresh1 243: local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22 afresh1 244:
1.50 afresh1 245: # TODO: Check hash for files before deleting
1.138 ! afresh1 246: [ "$VERBOSE" -gt 0 ] && echo -n "Uninstall $_pkg ..."
1.51 afresh1 247: _cwd="${_pkgdir}/$_pkg"
1.50 afresh1 248:
1.107 afresh1 249: if [ ! -e "$_cwd/+CONTENTS" ] ||
250: ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
251: echo "${0##*/}: $_pkg does not appear to be firmware" >&2
252: return 2
253: fi
254:
1.51 afresh1 255: set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50 afresh1 256:
257: while read -r c g; do
258: case $c in
1.51 afresh1 259: @cwd) _cwd="${DESTDIR}$g"
1.50 afresh1 260: ;;
261: @*) continue
262: ;;
1.52 afresh1 263: *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50 afresh1 264: ;;
265: esac
266: done < "${_pkgdir}/${_pkg}/+CONTENTS"
267:
268: # We specifically rm -f here because not removing files/dirs
269: # is probably not worth failing over.
270: for _r in "${_remove[@]}" ; do
271: if [ -d "$_r" ]; then
272: # Try hard not to actually remove recursively
273: # without rmdir on the install media.
1.95 afresh1 274: set +o noglob
1.50 afresh1 275: [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
1.95 afresh1 276: set -o noglob
1.50 afresh1 277: else
278: rm -f "$_r"
1.22 afresh1 279: fi
280: done
1.138 ! afresh1 281:
! 282: [ "$VERBOSE" -gt 0 ] && echo " done."
1.50 afresh1 283: }
1.1 afresh1 284:
1.59 afresh1 285: usage() {
1.122 afresh1 286: echo "usage: ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
1.59 afresh1 287: exit 2
288: }
289:
1.113 afresh1 290: ALL=false
1.87 afresh1 291: OPT_D=
1.131 afresh1 292: while getopts :adDnp:v name
1.59 afresh1 293: do
294: case "$name" in
1.113 afresh1 295: a) ALL=true ;;
1.111 afresh1 296: d) DELETE=true ;;
1.87 afresh1 297: D) OPT_D=true ;;
1.131 afresh1 298: n) DRYRUN=true ;;
1.121 afresh1 299: p) LOCALSRC="$OPTARG" ;;
1.138 ! afresh1 300: v) VERBOSE=$(( VERBOSE + 1 )) ;;
1.121 afresh1 301: :)
302: echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
303: usage 2
304: ;;
305: ?)
306: echo "${0##*/}: unknown option -- -$OPTARG" >&2
307: usage 2
308: ;;
1.59 afresh1 309: esac
310: done
311: shift $((OPTIND - 1))
312:
1.121 afresh1 313: if [ "$LOCALSRC" ]; then
314: if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
315: FWURL="${LOCALSRC}"
316: LOCALSRC=
317: else
318: LOCALSRC="${LOCALSRC:#file:}"
319: ! [ -d "$LOCALSRC" ] &&
320: echo "The path must be a URL or an existing directory" >&2 &&
321: exit 2
322: fi
323: fi
324:
1.122 afresh1 325: # "Download only" means local dir and don't install
1.87 afresh1 326: if [ "$OPT_D" ]; then
327: INSTALL=false
1.121 afresh1 328: LOCALSRC="${LOCALSRC:-.}"
1.130 afresh1 329: elif [ "$LOCALSRC" ]; then
330: DOWNLOAD=false
1.87 afresh1 331: fi
1.64 afresh1 332:
1.118 afresh1 333: if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
334: echo "need root privileges" >&2
335: exit 1
1.94 afresh1 336: fi
337:
1.123 afresh1 338: set -sA devices -- "$@"
1.111 afresh1 339:
340: if "$DELETE"; then
1.122 afresh1 341: [ "$OPT_D" ] && usage 22
1.111 afresh1 342:
1.113 afresh1 343: set -A installed
344: if [ "${devices[*]:-}" ]; then
345: "$ALL" && usage 22
346:
347: set -A installed -- $(
348: for d in "${devices[@]}"; do
349: f="${d##*/}" # only care about the name
350: f="${f%.tgz}" # allow specifying the package name
351: [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
352:
353: set -A i -- $( installed_firmware '' "$f-" '*' )
354:
355: if [ "${i[*]:-}" ]; then
356: echo "${i[@]}"
357: else
358: echo "No firmware found for '$d'" >&2
359: fi
360: done
361: )
362: elif "$ALL"; then
363: set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
364: fi
1.111 afresh1 365:
366: deleted=''
1.113 afresh1 367: if [ "${installed:-}" ]; then
1.111 afresh1 368: for fw in "${installed[@]}"; do
1.131 afresh1 369: if "$DRYRUN"; then
1.138 ! afresh1 370: [ "$VERBOSE" -gt 0 ] && echo "Delete $fw"
1.131 afresh1 371: else
372: delete_firmware "$fw" || continue
373: fi
1.112 afresh1 374: deleted="$deleted,$( firmware_devicename "$fw" )"
1.111 afresh1 375: done
1.113 afresh1 376: fi
1.111 afresh1 377:
378: deleted="${deleted:+${deleted#,}}"
379: echo "${0:##*/}: deleted ${deleted:-none}";
380:
381: exit
382: fi
1.125 afresh1 383:
384: if [ ! "$LOCALSRC" ]; then
385: LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
1.126 afresh1 386: REMOVE_LOCALSRC=true
1.125 afresh1 387: fi
388:
389: CFILE="$LOCALSRC/$CFILE"
1.58 afresh1 390:
1.113 afresh1 391: if [ "${devices[*]:-}" ]; then
392: "$ALL" && usage 22
393: else
1.138 ! afresh1 394: [ "$VERBOSE" -gt 0 ] && echo -n "Detect firmware ..."
1.124 afresh1 395: set -sA devices -- $( detect_firmware )
1.138 ! afresh1 396: [ "$VERBOSE" -gt 0 ] &&
1.101 afresh1 397: { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
1.50 afresh1 398: fi
1.91 afresh1 399:
400: [ "${devices[*]:-}" ] || exit
1.50 afresh1 401:
1.71 afresh1 402: if "$DOWNLOAD"; then
1.116 afresh1 403: set +o noclobber # we want to get the latest CFILE
1.64 afresh1 404: fetch "$CFILE"
1.116 afresh1 405: set -o noclobber
1.64 afresh1 406: ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
407: echo "Signature check of SHA256.sig failed" >&2 && exit 1
1.120 afresh1 408: elif [ ! -e "$CFILE" ]; then
409: # TODO: We shouldn't need a CFILE if all arguments are files.
410: echo "${0##*/}: $CFILE: No such file or directory" >&2
411: exit 2
1.64 afresh1 412: fi
1.50 afresh1 413:
1.103 afresh1 414: added=''
415: updated=''
1.115 afresh1 416: kept=''
1.70 afresh1 417: for f in "${devices[@]}"; do
418: d="$( firmware_devicename "$f" )"
419:
1.58 afresh1 420: if [ "$f" = "$d" ]; then
421: f=$( firmware_filename "$d" || true )
422: [ "$f" ] || continue
1.69 afresh1 423: f="$LOCALSRC/$f"
1.76 afresh1 424: elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70 afresh1 425: echo "Cannot download local file $f" >&2
426: exit 2
1.58 afresh1 427: fi
428:
1.110 afresh1 429: set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
1.50 afresh1 430:
1.68 afresh1 431: if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65 afresh1 432: for i in "${installed[@]}"; do
1.58 afresh1 433: if [ "${f##*/}" = "$i.tgz" ]; then
1.138 ! afresh1 434: [ "$VERBOSE" -gt 0 ] && echo "Keep $i"
1.115 afresh1 435: kept="$kept,$d"
1.11 afresh1 436: continue 2
1.1 afresh1 437: fi
438: done
1.50 afresh1 439: fi
1.1 afresh1 440:
1.72 afresh1 441: if [ -e "$f" ]; then
442: if "$DOWNLOAD"; then
1.138 ! afresh1 443: [ "$VERBOSE" -gt 0 ] && ! "$INSTALL" &&
1.134 afresh1 444: echo "Keep/Verify ${f##*/}"
1.131 afresh1 445: "$DRYRUN" || verify "$f" || continue
446: "$INSTALL" || kept="$kept,$d"
1.72 afresh1 447: # else assume it was verified when downloaded
448: fi
1.75 afresh1 449: elif "$DOWNLOAD"; then
1.131 afresh1 450: if "$DRYRUN"; then
1.138 ! afresh1 451: [ "$VERBOSE" -gt 0 ] && echo "Get/Verify ${f##*/}"
1.131 afresh1 452: else
1.138 ! afresh1 453: [ "$VERBOSE" -eq 1 ] && echo -n "Get/Verify ${f##*/} ..."
! 454: fetch "$f" &&
! 455: verify "$f" ||
! 456: { [ "$VERBOSE" -eq 1 ] && echo " failed."; continue; }
! 457: [ "$VERBOSE" -eq 1 ] && echo " done."
1.131 afresh1 458: fi
1.138 ! afresh1 459: "$INSTALL" || added="$added,$d"
1.75 afresh1 460: elif "$INSTALL"; then
1.72 afresh1 461: echo "Cannot install ${f##*/}, not found" >&2
462: continue
1.58 afresh1 463: fi
1.60 afresh1 464:
1.68 afresh1 465: "$INSTALL" || continue
1.11 afresh1 466:
1.103 afresh1 467: removed=false
1.65 afresh1 468: if [ "${installed[*]:-}" ]; then
1.50 afresh1 469: for i in "${installed[@]}"; do
1.131 afresh1 470: "$DRYRUN" || delete_firmware "$i"
1.103 afresh1 471: removed=true
1.50 afresh1 472: done
473: fi
1.11 afresh1 474:
1.131 afresh1 475: "$DRYRUN" || add_firmware "$f"
1.103 afresh1 476:
1.131 afresh1 477: f="${f##*/}"
478: f="${f%.tgz}"
1.103 afresh1 479: if "$removed"; then
1.138 ! afresh1 480: "$DRYRUN" && [ "$VERBOSE" -gt 0 ] && echo "Update $f"
1.114 afresh1 481: updated="$updated,$d"
1.103 afresh1 482: else
1.138 ! afresh1 483: "$DRYRUN" && [ "$VERBOSE" -gt 0 ] && echo "Install $f"
1.114 afresh1 484: added="$added,$d"
1.103 afresh1 485: fi
1.50 afresh1 486: done
1.1 afresh1 487:
1.114 afresh1 488: added="${added:#,}"
489: updated="${updated:#,}"
1.115 afresh1 490: kept="${kept:#,}"
1.117 afresh1 491: if "$INSTALL"; then
492: echo "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
493: else
494: echo "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
495: fi
FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>